#ifndef ACCELERATOR_HPP
#define ACCELERATOR_HPP

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------		
#include <Primitive.hpp>
#include <list>

namespace Render
{
	//-------------------------------------------------------------------------
	// Class Aggregate
	//-------------------------------------------------------------------------
	class Aggregate : public Primitive
	{
		public:
			//-----------------------------------------------------------------
			// C/D-Tor
			//-----------------------------------------------------------------
			Aggregate() : Primitive()
			{

			}
			//-----------------------------------------------------------------
			virtual ~Aggregate()
			{
				primitives.clear();
			}

			//-----------------------------------------------------------------
			// Add primitive to Accelerator
			//-----------------------------------------------------------------
			void Add(Primitive* _primitive)
			{
				primitives.push_back(_primitive);
			}

			//-----------------------------------------------------------------
			// Render primitive
			//-----------------------------------------------------------------
			virtual void Render() const
			{
				for(TPrimitiveCollection::const_iterator it= primitives.begin(); it != primitives.end(); ++it)
				{
					(*it)->Render();
				}
			}

		private:
			//-----------------------------------------------------------------
			// Forbidden operations
			//-----------------------------------------------------------------
			Aggregate(const Aggregate& _copy);
			Aggregate& operator=(const Aggregate& _copy);

			typedef std::list<Primitive*> TPrimitiveCollection;
			TPrimitiveCollection primitives;
	};
}

#endif // ACCELERATOR_HPP
