#ifndef SCENE_HPP
#define SCENE_HPP

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------		
#include <Primitive.hpp>
#include <Sphere.hpp>
#include <cassert>


namespace Render
{
	//-------------------------------------------------------------------------
	// Class Scene
	//-------------------------------------------------------------------------
	class Scene
	{
		public:
			//-----------------------------------------------------------------
			// C/D-Tor
			//-----------------------------------------------------------------
			Scene()
			{
				if(root==NULL)
					root = new Sphere();
			}
			//-----------------------------------------------------------------
			Scene(Primitive* _root) : root(_root)
			{
				assert(root!=NULL);
			}
			//-----------------------------------------------------------------
			~Scene()
			{
				delete root;
			}

			//-----------------------------------------------------------------
			// Render scene
			//-----------------------------------------------------------------
			void Render()
			{
				root->Render();
			}

		private:
			//-----------------------------------------------------------------
			// Forbidden operations
			//-----------------------------------------------------------------
			Scene(const Scene& _copy);
			Scene& operator=(const Scene& _copy);

		public:
			//-----------------------------------------------------------------
			// Attributes
			//-----------------------------------------------------------------
			Primitive* root;
	};
}

#endif // SCENE_HPP
