//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------

namespace Tools
{
	//--------------------------------------------------------------------------
	// MemoryManager methods
	//--------------------------------------------------------------------------	
	template<class AllocationPolicy, class TracePolicy>
	MemoryManager<AllocationPolicy,TracePolicy>::MemoryManager()
	{

	}
	//--------------------------------------------------------------------------	
	template<class AllocationPolicy, class TracePolicy>
	MemoryManager<AllocationPolicy,TracePolicy>::~MemoryManager()
	{

	}
	//--------------------------------------------------------------------------
	template<class AllocationPolicy, class TracePolicy>
	MemoryManager<AllocationPolicy,TracePolicy>& MemoryManager<AllocationPolicy,TracePolicy>::Instance()
	{
		static MemoryManager<AllocationPolicy,TracePolicy> instance;
		return instance;
	}
	//--------------------------------------------------------------------------
	template<class AllocationPolicy, class TracePolicy>
	void*  MemoryManager<AllocationPolicy,TracePolicy>::Allocate(size_t _size, const char* _file, int _line, bool _array)
	{
		// Allocate memory
		void* pointer = AllocationPolicy::Allocate(_size);

		// Trace allocation
		TracePolicy::TraceAllocation(pointer,_size,_file, _line, _array);

		return pointer;
	}
	//--------------------------------------------------------------------------
	template<class AllocationPolicy, class TracePolicy>
	void MemoryManager<AllocationPolicy,TracePolicy>::Deallocate(void* _pointer, bool _array)
	{
		// Trace desallocation
		TracePolicy::TraceDeallocation(_pointer, _array);

		// Desallocate memory
		AllocationPolicy::Deallocate(_pointer);
	}
	//--------------------------------------------------------------------------
	template<class AllocationPolicy, class TracePolicy>
	void MemoryManager<AllocationPolicy,TracePolicy>::Dump()
	{
		TracePolicy::Dump();
	}
}

