//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------		
#include <Scene.hpp>
#include <Sphere.hpp>
#include <Triangle.hpp>
#include <TriangleMesh.hpp>
#include <Accelerator.hpp>
#include <cstdio>

using namespace Render;

//-----------------------------------------------------------------------------		
// Expected trace
//
// Triangle::Render()
//-----------------------------------------------------------------------------		
void test1()
{
	Triangle* triangle = new Triangle();
	Scene scene(triangle);
	scene.Render();
}

//-----------------------------------------------------------------------------		
// Expected trace
//
// Sphere::Render()
//-----------------------------------------------------------------------------		
void test2()
{
	Sphere sphere;
	Scene scene(&sphere);
	scene.Render();
}

//-----------------------------------------------------------------------------		
// Expected trace
// Triangle::Render()
// Triangle::Render()
// Triangle::Render()
// Triangle::Render()
//-----------------------------------------------------------------------------		
void test3()
{
	TriangleMesh* mesh = new TriangleMesh("four");
	Scene scene(mesh);
	scene.Render();
}

//-----------------------------------------------------------------------------		
// Expected trace
//
// Triangle::Render()
// Sphere::Render()
// Triangle::Render()
// Triangle::Render()
// Triangle::Render()
// Triangle::Render()
//-----------------------------------------------------------------------------		
void test4()
{
	Triangle* triangle = new Triangle();
	Sphere* sphere = new Sphere();
	TriangleMesh* mesh = new TriangleMesh("four");

	Aggregate* aggregate = new  Aggregate();
	aggregate->Add(triangle);
	aggregate->Add(sphere);
	aggregate->Add(mesh);

	Scene scene(aggregate);
	scene.Render();
}


//-----------------------------------------------------------------------------		
// Expected trace
//
// Sphere::Render()
//-----------------------------------------------------------------------------	
void test5()
{
	Scene scene;
	scene.Render();
}

int main()
{
	printf("Test 1 ----------------------------------------------------\n");
	test1();
	printf("Test 2 ----------------------------------------------------\n");
	test2();
	printf("Test 3 ----------------------------------------------------\n");
	test3();
	printf("Test 4 ----------------------------------------------------\n");
	test4();
	printf("Test 5 ----------------------------------------------------\n");
	test5();
	return 0;
}
