#ifndef SPHERE_HPP
#define SPHERE_HPP

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------		
#include <Primitive.hpp>
#include <new>
#include <cstdlib>

namespace Render
{
	//-------------------------------------------------------------------------
	// Class Sphere
	//-------------------------------------------------------------------------
	class Sphere : public Primitive
	{
		public:
			//-----------------------------------------------------------------
			// C/D-Tor
			//-----------------------------------------------------------------
			Sphere()
			{

			}
			//-----------------------------------------------------------------
			virtual ~Sphere()
			{

			}

			//-----------------------------------------------------------------
			// Operators
			//-----------------------------------------------------------------
			static void* operator new(std::size_t _size)
			{
				printf("Sphere::new\n");
				void* pointer = malloc(_size);
				if(pointer == NULL)
					throw std::bad_alloc();
				return pointer;
			}
			//-----------------------------------------------------------------
			static void operator delete(void* _pointer)
			{
				printf("Sphere::delete\n");
				free(_pointer);		
			}
			//-----------------------------------------------------------------
			static void* operator new[](std::size_t _size)
			{
				printf("Sphere::new[]\n");
				void* pointer = malloc(_size);
				if(pointer == NULL)
					throw std::bad_alloc();
				return pointer;
			}
			//-----------------------------------------------------------------
			static void operator delete[](void* _pointer)
			{
				printf("Sphere::delete[]\n");
				free(_pointer);		
			}

			//-----------------------------------------------------------------
			// Render primitive
			//-----------------------------------------------------------------
			virtual void Render() const
			{
				printf("Sphere::Render()\n");
			}

		private:
			//-----------------------------------------------------------------
			// Forbidden operations
			//-----------------------------------------------------------------
			Sphere(const Sphere& _copy);
			Sphere& operator=(const Sphere& _copy);
	};
}

#endif // SPHERE_HPP
