#ifndef TRIANGLE_HPP
#define TRIANGLE_HPP

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------		
#include <Primitive.hpp>
#include <new>
#include <cstdlib>

namespace Render
{
	//-------------------------------------------------------------------------
	// Class Triangle
	//-------------------------------------------------------------------------
	class Triangle : public Primitive
	{
		public:
			//-----------------------------------------------------------------
			// C/D-Tor
			//-----------------------------------------------------------------
			Triangle()
			{

			}
			//-----------------------------------------------------------------
			virtual ~Triangle()
			{

			}

			//-----------------------------------------------------------------
			// Operators
			//-----------------------------------------------------------------
			static void* operator new(std::size_t _size)
			{
				printf("Triangle::new\n");
				void* pointer = malloc(_size);
				if(pointer == NULL)
					throw std::bad_alloc();
				return pointer;
			}
			//-----------------------------------------------------------------
			static void operator delete(void* _pointer)
			{
				printf("Triangle::delete\n");
				free(_pointer);		
			}
			//-----------------------------------------------------------------
			static void* operator new(std::size_t _size, void* _memory)
			{
				printf("Triangle::new placement\n");
				return _memory;
			}
			//-----------------------------------------------------------------
			static void* operator new(std::size_t _size, int _line , const char* _file)
			{
				printf("Triangle::new (line:%d, file:%s)\n",_line,_file);
				void* pointer = malloc(_size);
				if(pointer == NULL)
					throw std::bad_alloc();
				return pointer;
			}


			//-----------------------------------------------------------------
			// Render primitive
			//-----------------------------------------------------------------
			virtual void Render() const
			{
				printf("Triangle::Render()\n");
			}

		private:
			//-----------------------------------------------------------------
			// Forbidden operations
			//-----------------------------------------------------------------
			Triangle(const Triangle& _copy);
			Triangle& operator=(const Triangle& _copy);
	};
}

#endif // TRIANGLE_HPP
