#ifndef MEMORY_POOL_HPP
#define MEMORY_POOL_HPP

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------		
#include <vector>

namespace Tools
{
	//-------------------------------------------------------------------------
	// Class MemoryPool
	//-------------------------------------------------------------------------
	template<typename T>
	class MemoryPool
	{
		public:
			//-----------------------------------------------------------------
			// C/D-Tor
			//-----------------------------------------------------------------
			MemoryPool();
			~MemoryPool();

			//-----------------------------------------------------------------
			// Allocates a block of fixed size
			//-----------------------------------------------------------------
			void* Allocate();

			//-----------------------------------------------------------------
			// Deallocates a block previously allocated with Allocate
			// (undefined behavior if called with the wrong pointer)
			//-----------------------------------------------------------------
			void Desallocate(void* _ptr);

		private:
			//-----------------------------------------------------------------
			// Forbidden operations
			//-----------------------------------------------------------------
			MemoryPool(const MemoryPool& _copy);
			MemoryPool& operator=(const MemoryPool& _copy);
	};
}

//-----------------------------------------------------------------------------
// Includes inline definition
//-----------------------------------------------------------------------------	
#include "MemoryPool.inl"

#endif // MEMORY_POOL_HPP
