//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include "MemoryPool.hpp"
#include <cstdio>
#include <ctime>

#define NUM_ALLOCATIONS 1000000

struct A
{
	char a[4];
	int b;
	float c; 
};

typedef A Type;

/*
void test1()
{
	Tools::MemoryPool<Type> pool;
	clock_t tic = clock();
	for(int i=0; i<NUM_ALLOCATIONS; ++i)
	{
		Type* a = static_cast<Type*>(pool.Allocate());
		pool.Desallocate(static_cast<void*>(a));
	}
	clock_t tac = clock() - tic;
	printf("test1:%f\n", tac/(float)CLOCKS_PER_SEC);
}

void test2()
{
	clock_t tic = clock();
	for(int i=0; i<NUM_ALLOCATIONS; ++i)
	{
		Type* a = new Type();
		delete a;
	}
	clock_t tac = clock() - tic;
	printf("test2:%f\n", tac/(float)CLOCKS_PER_SEC);
}
*/


void test3()
{
	Type* a[NUM_ALLOCATIONS];

	clock_t tic = clock();
	for(int i=0; i<NUM_ALLOCATIONS; ++i)
	{
		a[i] = new A();
	}

	for(int i=0; i<NUM_ALLOCATIONS; ++i)
	{
		delete a[i];
	}
	clock_t tac = clock() - tic;
	printf("test3:%f\n", tac/(float)CLOCKS_PER_SEC);
}

void test4()
{
	Tools::MemoryPool<Type> pool;		
	Type* a[NUM_ALLOCATIONS];

	clock_t tic = clock();
	for(int i=0; i<NUM_ALLOCATIONS; ++i)
	{
		a[i] = static_cast<Type*>(pool.Allocate());
	}

	for(int i=0; i<NUM_ALLOCATIONS; ++i)
	{
		pool.Desallocate(static_cast<void*>(a[i]));
	}
	clock_t tac = clock() - tic;
	printf("test4:%f\n", tac/(float)CLOCKS_PER_SEC);
}

int main()
{
//	test1();
//	test2();
	test3();
	test4();
	return 0;
}
