#ifndef SHARED_POINTER_HPP
#define SHARED_POINTER_HPP

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------

namespace Tools
{
    template <class T>
    class SharedPointer
    {
    public :
		//---------------------------------------------------------------------
        // Constructor
		//---------------------------------------------------------------------
        SharedPointer();
        SharedPointer(T* pointer);
        SharedPointer(const SharedPointer& copy);                
        const SharedPointer& operator =(const SharedPointer& copy);        

		//---------------------------------------------------------------------
        // Destructor        
		//---------------------------------------------------------------------
        ~SharedPointer();        

		//---------------------------------------------------------------------
        // Reference operator                
		//---------------------------------------------------------------------
        T& operator*() const;
        T* operator->() const;

		//---------------------------------------------------------------------
        // Cast operator         
		//---------------------------------------------------------------------
		operator bool();

    private :
		//---------------------------------------------------------------------
		// Swap pointers
		//---------------------------------------------------------------------
        void Swap(SharedPointer& pointer);

		//---------------------------------------------------------------------
		// Attributs
		//---------------------------------------------------------------------
        T*   object;
        int* objectCounter; 
    };    
}

//-----------------------------------------------------------------------------
// Includes inline definition
//-----------------------------------------------------------------------------
#include "SharedPointer.inl"


#endif // SHARED_POINTER_HPP
